// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias AnswerShippingQueryCompletion = (_ result: Bool?, _ error: DataTaskError?) -> ()

    /// If you sent an invoice requesting a shipping address and the parameter is_flexible was specified, the Bot API will send an Update with a shipping_query field to the bot. Use this method to reply to shipping queries. On success, True is returned.
    /// - Parameters:
    ///     - shipping_query_id: Unique identifier for the query to be answered
    ///     - ok: Specify True if delivery to the specified address is possible and False if there are any problems (for example, if delivery to the specified address is not possible)
    ///     - shipping_options: Required if ok is True. A JSON-serialized array of available shipping options.
    ///     - error_message: Required if ok is False. Error message in human readable form that explains why it is impossible to complete the order (e.g. "Sorry, delivery to your desired address is unavailable'). Telegram will display this message to the user.
    /// - Returns: Bool on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#answershippingquery>
    @discardableResult
    public func answerShippingQuerySync(
            shippingQueryId: String,
            ok: Bool,
            shippingOptions: [ShippingOption]? = nil,
            errorMessage: String? = nil,
            _ parameters: [String: Any?] = [:]) -> Bool? {
        return requestSync("answerShippingQuery", defaultParameters["answerShippingQuery"], parameters, [
            "shipping_query_id": shippingQueryId,
            "ok": ok,
            "shipping_options": shippingOptions,
            "error_message": errorMessage])
    }

    /// If you sent an invoice requesting a shipping address and the parameter is_flexible was specified, the Bot API will send an Update with a shipping_query field to the bot. Use this method to reply to shipping queries. On success, True is returned.
    /// - Parameters:
    ///     - shipping_query_id: Unique identifier for the query to be answered
    ///     - ok: Specify True if delivery to the specified address is possible and False if there are any problems (for example, if delivery to the specified address is not possible)
    ///     - shipping_options: Required if ok is True. A JSON-serialized array of available shipping options.
    ///     - error_message: Required if ok is False. Error message in human readable form that explains why it is impossible to complete the order (e.g. "Sorry, delivery to your desired address is unavailable'). Telegram will display this message to the user.
    /// - Returns: Bool on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#answershippingquery>
    public func answerShippingQueryAsync(
            shippingQueryId: String,
            ok: Bool,
            shippingOptions: [ShippingOption]? = nil,
            errorMessage: String? = nil,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: AnswerShippingQueryCompletion? = nil) {
        return requestAsync("answerShippingQuery", defaultParameters["answerShippingQuery"], parameters, [
            "shipping_query_id": shippingQueryId,
            "ok": ok,
            "shipping_options": shippingOptions,
            "error_message": errorMessage],
            queue: queue, completion: completion)
    }
}

