// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias GetChatMembersCountCompletion = (_ result: Int?, _ error: DataTaskError?) -> ()

    /// Use this method to get the number of members in a chat. Returns Int on success.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target supergroup or channel (in the format @channelusername)
    /// - Returns: Int on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#getchatmemberscount>
    @discardableResult
    public func getChatMembersCountSync(
            chatId: ChatId,
            _ parameters: [String: Any?] = [:]) -> Int? {
        return requestSync("getChatMembersCount", defaultParameters["getChatMembersCount"], parameters, [
            "chat_id": chatId])
    }

    /// Use this method to get the number of members in a chat. Returns Int on success.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target supergroup or channel (in the format @channelusername)
    /// - Returns: Int on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#getchatmemberscount>
    public func getChatMembersCountAsync(
            chatId: ChatId,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: GetChatMembersCountCompletion? = nil) {
        return requestAsync("getChatMembersCount", defaultParameters["getChatMembersCount"], parameters, [
            "chat_id": chatId],
            queue: queue, completion: completion)
    }
}

