// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias SetChatTitleCompletion = (_ result: Bool?, _ error: DataTaskError?) -> ()

    /// Use this method to change the title of a chat. Titles can't be changed for private chats. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Returns True on success.
    /// Note: In regular groups (non-supergroups), this method will only work if the ‘All Members Are Admins’ setting is off in the target group.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - title: New chat title, 1-255 characters
    /// - Returns: Bool on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#setchattitle>
    @discardableResult
    public func setChatTitleSync(
            chatId: ChatId,
            title: String,
            _ parameters: [String: Any?] = [:]) -> Bool? {
        return requestSync("setChatTitle", defaultParameters["setChatTitle"], parameters, [
            "chat_id": chatId,
            "title": title])
    }

    /// Use this method to change the title of a chat. Titles can't be changed for private chats. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Returns True on success.
    /// Note: In regular groups (non-supergroups), this method will only work if the ‘All Members Are Admins’ setting is off in the target group.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - title: New chat title, 1-255 characters
    /// - Returns: Bool on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#setchattitle>
    public func setChatTitleAsync(
            chatId: ChatId,
            title: String,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: SetChatTitleCompletion? = nil) {
        return requestAsync("setChatTitle", defaultParameters["setChatTitle"], parameters, [
            "chat_id": chatId,
            "title": title],
            queue: queue, completion: completion)
    }
}

